﻿package vfl.as3.roteiro
{
	import flash.events.EventDispatcher;	
	import flash.media.Sound;
	import flash.media.SoundChannel;	
	import flash.utils.ByteArray;
	import flash.utils.setInterval;
	import flash.utils.clearInterval;
	import flash.utils.setTimeout;
	import flash.media.SoundTransform;
	
	import flash.events.Event;
		
	public class Dublagem extends EventDispatcher
	{
		public const TAXA_AVANCO = 0.03;
		
		private var classeSom 	: Class;
		private var dados		: Array;
		private var interval	: int;
		
		private var som			: Sound;
		private var canal		: SoundChannel;
		private var estado		: String;
		
		private var recorte			: Array;
		private var soundTransform_	: SoundTransform;
		
		public function Dublagem(pClasseSom, pSoundTransform = null, pRecorte = null)
		{
			classeSom = pClasseSom;			
			dados = new Array();
			estado= "";
			
			if (pRecorte != null) recorte = pRecorte;
			else
			{
				recorte = new Array();
				recorte.push(0);
				recorte.push(0);
			}
			
			if (pSoundTransform != null) soundTransform_ = pSoundTransform;
			else soundTransform_ = new SoundTransform(1);
			
			ExtrairDados();
		}
		
		public function ExtrairDados()
		{
			som 		= new classeSom();
			var tamanho	= Math.floor ((som.length/1000)*44100);
					
			var bytes = new ByteArray();
			som.extract(bytes, tamanho);
			
			var step = Math.floor(bytes.length/4096);
			do step-- while ( step % 4 );
	
			var left, right;
			bytes.position = 0;

			for (var c:int = 0; c < 4096; c++)
			{
				left 	= bytes.readFloat() * 128;
				right 	= bytes.readFloat() * 128;
				bytes.position = c*step;
				dados.push(left);
			}
		}
		
		public function Iniciar()
		{
			trace("[Dublagem] Iniciar");
			if (recorte[0] != 0) canal = som.play(recorte[0],0,soundTransform_);
			else canal = som.play(0,0,soundTransform_);
			
			canal.addEventListener(Event.SOUND_COMPLETE, EncerrarEvento);

			interval = setInterval(Monitorar, 10);
			dispatchEvent(new DublagemEvento(DublagemEvento.INICIO, null));
		}
		
		public function Monitorar()
		{
			var percent = canal.position / (som.length - recorte[1]);
			dispatchEvent(new DublagemEvento(DublagemEvento.PROGRESSO, {progresso: percent}));
			if (percent >= 1) 
			{
				EncerrarEvento(null);
				return ;
				//percent = 1;
			}

			percent += TAXA_AVANCO				
			var pos 	= Math.floor(percent * dados.length)-1;
			
			//trace( dados[pos]);
			var f = Math.abs(dados[pos]);
			//trace(f);
			if (f >= 0.1)
			{
				if (estado != "Falando")
				{
					//setTimeout(DespacharFalando, 40);
					//trace("[Dublagem.as] Inicio Fala");
					dispatchEvent(new DublagemEvento(DublagemEvento.INICIO_FALA, null));
					estado = "Falando";
				}
			}
			else
			{
				if (estado != "Pausa")
				{
					//trace("[Dublagem.as] Pausa");
					dispatchEvent(new DublagemEvento(DublagemEvento.PAUSA_FALA, null));
					estado = "Pausa";
				}
			}			
		}

		public function DespacharFalando()
		{
			dispatchEvent(new DublagemEvento(DublagemEvento.INICIO_FALA, null));
		}
	
		public function EncerrarEvento(evt)
		{
			Encerrar();
			dispatchEvent(new DublagemEvento(DublagemEvento.FIM, null));
		}
	
		public function Encerrar()
		{			
			clearInterval(interval);
			canal.removeEventListener(Event.SOUND_COMPLETE, EncerrarEvento);
			canal.stop();
		}
		
		public function GetTempoTotal()
		{
			if (som != null) 
			{
				return som.length;
			}
			return 0;
		}
	}
}