﻿package vfl.as3.roteiro
{
	import flash.events.EventDispatcher;
	import flash.display.DisplayObject;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import vfl.as3.util.StringUtils;
	import flash.utils.Timer;
	import flash.utils.setTimeout;
	import flash.utils.getTimer;
	
	import gs.TweenLite;
	
	import flash.filters.DropShadowFilter;
	
	public class Fala extends EventDispatcher
	{
		// Intervalo em milisegundos de exibição entre as
		// letras de uma frase.
		static const TEMPO_POR_LETRA	= 70; // Influencia no tempo que o personagem move boca.
		static const TEMPO_MINIMO 		= 3000;
		static const AJUSTE_TEMPO 		= 50;
		
		public var texto 		= "";

		// Controle de tempo.
		public var tempoTotal		= 0;		
		public var tempoInicial		= 0;
		public var timer			= null;
		
		// Palavras-chave.
		public var palavrasChave  	= null;
		
		
		public function Fala(pTexto	: String)
		{	
			texto			= pTexto;			
			ExtrairPalavrasChave();
		}
		
		// Identifica as palavras-chave presentes no texto.
		public function ExtrairPalavrasChave()
		{			
			var inicio, tipo, numero, palavra, fim;
			var contagemTags = 0;
			var pTextoPuro 	 = "";
			
			palavrasChave 	= new Array();
			for (var i = 0; i < texto.length; i++)
			{
				var c = texto.charAt(i);
				if (c == "[")
				{
					//contagemTags++;
					
					// Tipo.
					i++; contagemTags++;
					tipo = "";
					while (texto.charAt(i) != "-")
					{
						tipo += texto.charAt(i++);
						contagemTags++;
					}
					
					// Identificador (pula hifen).
					numero = "";
					i++; contagemTags ++;
					while (texto.charAt(i) != "]")
					{						
						numero += texto.charAt(i++);
						contagemTags++;
					}					
					
					// "]"
					i++; contagemTags++;
					
					// Armazena a palavra ou expressao.		
					inicio = i - contagemTags;
					palavra = "";
					while (texto.charAt(i) != "[")
					{
						palavra += texto.charAt(i++);
					}
					fim = i-1 - contagemTags;
					pTextoPuro += palavra;
					
					//trace(palavra + ": " + inicio);
					
					// Encontra o fim da tag.
					while (texto.charAt(i) != "]") 
					{
						i++;
						contagemTags++;
						if (i >= texto.length) break;
					}
					//i++; 
					contagemTags++;
					
					// Armazena.
					palavrasChave.push({palavra: palavra, inicio: inicio, 
									    fim: fim, tipo: tipo, identificador: numero,
										executada: false, finalizada: false});
				}
				else 
				{
					if (c == "|") contagemTags++
					pTextoPuro += c;
				}
			}			
			
			texto = pTextoPuro;
		}
		
		public function Iniciar()
		{
			if (tempoTotal == 0) tempoTotal 	= TEMPO_POR_LETRA * texto.length;
			tempoInicial= getTimer();
			
			// Monitora o progressso da fala.
			timer = new Timer(1);
			timer.addEventListener("timer", Progresso);
			timer.start();
			
			dispatchEvent(new FalaEvento(FalaEvento.INICIO));
			setTimeout(Fim, tempoTotal);
		}
		
		public function SetTempoTotal(pTempoTotal)
		{
			tempoTotal = pTempoTotal;
		}
		
		public function Progresso(evt)
		{
			var tempoPassado = getTimer() + AJUSTE_TEMPO - tempoInicial;
			var progresso 	 = (tempoPassado / tempoTotal);
			
			var letraAtual = Math.round(progresso * texto.length);
			for (var i = 0; i < palavrasChave.length; i++)
			{
				//trace(letraAtual + " " + palavrasChave[i].fim + " - " + palavrasChave[i].finalizada);
				
				if ( !palavrasChave[i].executada && 
					 letraAtual >= palavrasChave[i].inicio )
				{
					palavrasChave[i].executada = true;
					dispatchEvent(new FalaEvento(FalaEvento.PALAVRA_CHAVE_INICIO, 
												 palavrasChave[i].palavra,
												 palavrasChave[i].tipo,
												 palavrasChave[i].identificador,
												 palavrasChave[i].inicio,
												 palavrasChave[i].fim));
				}
				if ( 	!palavrasChave[i].finalizada && 
						 	letraAtual >= palavrasChave[i].fim )
				{
					palavrasChave[i].finalizada = true;
					dispatchEvent(new FalaEvento(FalaEvento.PALAVRA_CHAVE_FIM, 
												 palavrasChave[i].palavra,
												 palavrasChave[i].tipo,
												 palavrasChave[i].identificador,
												 palavrasChave[i].inicio,
												 palavrasChave[i].fim));					
				}
			}
			
			dispatchEvent(new FalaEventoProgresso(FalaEventoProgresso.PROGRESSO, progresso));
		}
		
		public function Fim()
		{
			dispatchEvent(new FalaEvento(FalaEvento.FIM));
		}
		
		public function GetProgresso()
		{
			var tempoPassado = getTimer() - tempoInicial();
			return (tempoPassado / tempoTotal);
		}
		
		
		public function Encerrar()
		{
			timer.stop();
			timer.removeEventListener("timer", Progresso);
		}
		
		public function GetTexto()
		{
			return texto;
		}
		
		/*
		public function FimInicioExibicao()
		{			
			dispatchEvent(new LegendaEvento(LegendaEvento.INICIAR_FALA));
			
			// Tempo que a legenda permanece visivel.
			var tempo =  TEMPO_LEGENDA * texto.length;
			tempo     = ( tempo > TEMPO_MINIMO ? tempo : TEMPO_MINIMO);
			setTimeout(FimExibicao, tempo);
			
			// Tempo que o personagem permanece movendo a boca.
			tempoBoca 	= TEMPO_BOCA  * texto.length;
			setTimeout(FimMoverBoca, tempoBoca);
			
			// Atividade de movimentação da boca.
			tempoBocaInicial = getTimer();
			timer = new Timer(1);
			timer.addEventListener("timer", MovendoBoca);
			timer.start();
		}
		
		public function MovendoBoca(evt)
		{
			var tempoTotal = getTimer() - tempoBocaInicial;
			dispatchEvent(new LegendaEvento(LegendaEvento.FALAR, tempoTotal/tempoBoca));
		}
		
		public function FimExibicao()
		{
			TweenLite.to(caixaTexto, 0.5, {alpha: 0, onComplete: FimExibicao2});
		}
		
		public function FimMoverBoca()
		{
			timer.stop();
			timer.removeEventListener("timer", MovendoBoca);
			dispatchEvent(new LegendaEvento(LegendaEvento.PARAR_FALA));
		}
		
		public function FimExibicao2()
		{
			dispatchEvent(new LegendaEvento(LegendaEvento.FIM_LEGENDA));
		}
		
		public function Remover()
		{
			alvo.removeChild(caixaTexto);
		}
		*/
	}
}